    ;
    ; AHCC interface for Wizzcat 12kHz Protracker replay (STE only)
    ; based on the Wizzcat interface by GT Turbo / Cerebral Vortex for GFABASIC
    ;
    ; AHCC interface (c) 2011 by Simon Sunnyboy / Paradize
    ;

    export Wizzcat_Init
    export Wizzcat_Play
    export Wizzcat_Stop

    CODE

Wizzcat_Init:
    movem.l d0-a6,-(sp)
    cmpi.l #'Wizz',wizzcat_initmark
    beq end_init
    ; relocate Wizzcat routine:
    movem.l regs,d0-a6

    lea wizzcat_rout,a0
    bsr reloc
    ; mark routine as ready
    move.l #'Wizz',wizzcat_initmark
    clr.w wizzcat_playing
end_init:
    movem.l (sp)+,d0-a6
    rts

Wizzcat_Play:
    movem.l d0-a6,-(sp)
    cmpi.l #'Wizz',wizzcat_initmark
    bne assert_wizzcat_failed
    cmpi.w #0,wizzcat_playing
    bne assert_wizzcat_failed
    move.w #-1,wizzcat_playing

    movem.l regs,d0-d7

    clr.l a2
    clr.l a3
    clr.l a4
    clr.l a5
    clr.l a6

    bsr wizzcat_rout


    movem.l (sp)+,d0-a6
    rts

Wizzcat_Stop:
    movem.l d0-a6,-(sp)
    cmpi.l #'Wizz',wizzcat_initmark
    bne assert_wizzcat_failed
    cmpi.w #-1,wizzcat_playing
    bne assert_wizzcat_failed
    clr.w wizzcat_playing

    movem.l regs,d0-a6

    bsr wizzcat_rout+2

assert_wizzcat_failed:
    movem.l (sp)+,d0-a6
    rts

    dc.b "--RELOC--",0
    even
reloc:
    incbin "reloc.bin"
    even
    dc.b "--WIZZCAT--",0
    even
wizzcat_rout:
    incbin "wizzcat.bin"
    even
    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    even
    DATA
regs:
    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    even
wizzcat_initmark:
    dc.l 0
wizzcat_playing:
    dc.w 0
    even

    END
